C *** Subroutine FLT2DQ_P                     Last revision: 04-Jun-03
C
C     Generates flt2dq.lay Tecplot layout file
C               flt2dq.sty Tecplot style file
C               flt2dq.itp Techplot legend file (Techplot!)
C
      Subroutine FLT2DQ_P (bunix,y_max,ydot_max,ndim,y0)
      Implicit   Logical(B),COMPLEX*16(C),Real*8(D-H,O-Z)
      Dimension  y0(ndim)
      Character  z_style*100,z_comment*40,z_uhr*8,z_datum*8
      Real*8     m1,m2,k1,k2,kap,a0,km
      Real*8     ans,ans1,lmd1,lmd2,qh1,qh2
      Common    /FLT2DQPar/m1,m2,sm,d1,d2,k1,k2,km,kap,a0,f0,ph0,phase
      Common    /FLT2DQEvl/fs,omred,xdr,dmach,uom01,uom02,f01,f02
      Common    /FLT2DQLay/t_anf,t_end,z_comment
C
C ... Range for Frequency analysis
      If (abs(a0) .gt. 1d-10) then
          f_end0 = max(f02,f0)
      Else
          f_end0 = f02
      End if
      call SCALE(f_end,f_end0)
C ... Scaling
      call SCALE (y_end,y_max)
      call SCALE (ydot_end,ydot_max)
C
C ... Parameters for graphical display (TechPlot Software)
      if (bunix) goto 250
      ix = 7500
      iy = 9400
      iydif = 320
      iobj  = 10
C ... Character size
      write (25,'(''C 180 300'')')
      write (25,'(''D 2''/''P 7'')')
C ... Titel
      write (25,'(''{ '',i2)') iobj
      write (25,'(''TL '',I4,1X,I4,1X,a20)')
     #       ix,iy,'Parameters:         '
      write (25,'(''D 2''/''P 7''/''} '',I2)') iobj
C
C     One line skipped
      iy = iy-80
C
C ... Initial values
      iy = iy-iydif
      write (25,'(''{ '',i2)') iobj
      write (25,'(''TL '',I4,1X,I4,1X,''Y&&T{01}  = '',F5.2,
     #            ''   t&&TA = '',F6.1)')
     #       ix,iy,y0(3),t_anf
      write (25,'(''D 2''/''P 7''/''} '',I2)') iobj
      iy = iy-iydif
      write (25,'(''{ '',i2)') iobj
      write (25,'(''TL '',I4,1X,I4,1X,''Y&&T{02}  = '',F5.2,
     #            ''   t&&TE = '',1PG9.2)')
     #       ix,iy,y0(4),t_end
      write (25,'(''D 2''/''P 7''/''} '',I2)') iobj
C
C     One line skipped
      iy = iy-80
C
C ... Mass matrix
      iy = iy-iydif
      write (25,'(''{ '',i2)') iobj
      write (25,'(''TL '',I4,1X,I4,1X,''M&&T1  = '',
     #       F6.3,'' kg'')')
     #       ix,iy,m1
      write (25,'(''D 2''/''P 7''/''} '',I2)') iobj
      iy = iy-iydif
      write (25,'(''{ '',i2)') iobj
      write (25,'(''TL '',I4,1X,I4,1X,''M&&T2  = '',
     #       F6.3,'' kg'')')
     #       ix,iy,m2
      write (25,'(''D 2''/''P 7''/''} '',I2)') iobj
      iy = iy-iydif
      write (25,'(''{ '',i2)') iobj
      write (25,'(''TL '',I4,1X,I4,1X,''S&&Tm  = '',
     #       F6.3,'' kg'')')
     #       ix,iy,sm
      write (25,'(''D 2''/''P 7''/''} '',I2)') iobj
C
C     One line skipped
      iy = iy-80
C
C ... Damping
      iy = iy-iydif
      write (25,'(''{ '',i2)') iobj
      write (25,'(''TL '',I4,1X,I4,1X,''D&&T1  = '',
     #       F6.3,'' kg/s'')')
     #       ix,iy,d1
      write (25,'(''D 2''/''P 7''/''} '',I2)') iobj
      iy = iy-iydif
      write (25,'(''{ '',i2)') iobj
      write (25,'(''TL '',I4,1X,I4,1X,''D&&T2  = '',
     #       F6.3,'' kg/s'')')
     #       ix,iy,d2
C     One line skipped
      iy = iy-80
C
C ... Stiffness and frequency
      iy = iy-iydif
      write (25,'(''{ '',i2)') iobj
      write (25,'(''TL '',I4,1X,I4,1X,''K&&T1  = '',
     #       1PG10.3,'' kg/s&&H2'')')
     #       ix,iy,k1
      write (25,'(''D 2''/''P 7''/''} '',I2)') iobj
      iy = iy-iydif
      write (25,'(''{ '',i2)') iobj
      write (25,'(''TL '',I4,1X,I4,1X,''K&&T2  = '',
     #       1PG10.3,'' kg/s&&H2'')')
     #       ix,iy,k2
      iy = iy-iydif
      write (25,'(''{ '',i2)') iobj
      write (25,'(''TL '',I4,1X,I4,1X,''K&&Tm  = '',
     #       1PG10.3,'' kg/s&&H2'')')
     #       ix,iy,km
      write (25,'(''D 2''/''P 7''/''} '',I2)') iobj
C     One line skipped
      iy = iy-80
      iy = iy-iydif
      write (25,'(''{ '',i2)') iobj
C xxx write (25,'(''TL '',I4,1X,I4,1X,''&&Ek   =  '',
C xxx#       F6.2,'' kg/s&&H2'')')
C xxx#       ix,iy,kap
      write (25,'(''TL '',I4,1X,I4,1X,''f&&Ts   = '',
     #       1PG10.3,'' N/m'')')
     #       ix,iy,fs
C     One line skipped
      iy = iy-80
      iy = iy-iydif
      write (25,'(''{ '',i2)') iobj
      write (25,'(''TL '',I4,1X,I4,1X,''f&&T0&&T1  = '',
     #       F6.3,'' Hz'')')
     #       ix,iy,f01
      write (25,'(''D 2''/''P 7''/''} '',I2)') iobj
      iy = iy-iydif
      write (25,'(''{ '',i2)') iobj
      write (25,'(''TL '',I4,1X,I4,1X,''f&&T0&&T2  = '',
     #       F6.3,'' Hz'')')
     #       ix,iy,f02
C
C ... Parameters for graphical display (Tecplot Software, not Techplot!)
  250 Continue
  300 Continue
      Read (16,'(A100)',END=310) z_style
      if (index (z_style,'# FRAME02_RANGEX') .gt. 0) then
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   RANGEMIN = '',F10.3)') 0d0
          WRITE (26,'(A100)') z_style
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   RANGEMAX = '',F10.3)') t_end
          WRITE (26,'(A100)') z_style
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   GRSPACING = '',F10.3)') +t_end/4
          WRITE (26,'(A100)') z_style
      else if(index (z_style,'# FRAME03_RANGEX') .gt. 0) then
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   RANGEMIN = '',F10.3)') 0d0
          WRITE (26,'(A100)') z_style
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   RANGEMAX = '',F10.3)') t_end
          WRITE (26,'(A100)') z_style
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   GRSPACING = '',F10.3)') +t_end/4
          WRITE (26,'(A100)') z_style
      else if(index (z_style,'# FRAME04_RANGEX') .gt. 0) then
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   RANGEMIN = '',F10.3)') 0d0
          WRITE (26,'(A100)') z_style
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   RANGEMAX = '',F10.3)') f_end
          WRITE (26,'(A100)') z_style
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   GRSPACING = '',F10.3)') +f_end/4
          WRITE (26,'(A100)') z_style
      else if(index (z_style,'# FRAME05_RANGEX') .gt. 0) then
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   RANGEMIN = '',F10.3)') -y_end
          WRITE (26,'(A100)') z_style
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   RANGEMAX = '',F10.3)') +y_end
          WRITE (26,'(A100)') z_style
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   GRSPACING = '',F10.3)') +y_end/2
          WRITE (26,'(A100)') z_style
      else if(index (z_style,'# FRAME05_RANGEY') .gt. 0) then
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   RANGEMIN = '',F10.3)') -ydot_end
          WRITE (26,'(A100)') z_style
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   RANGEMAX = '',F10.3)') +ydot_end
          WRITE (26,'(A100)') z_style
          Read (16,'(A100)',END=310) z_style
          Write (z_style,'(''   GRSPACING = '',F10.3)') +ydot_end/2
          WRITE (26,'(A100)') z_style
      else
          write (26,'(A)') z_style
      end if
      goto 300
  310 Continue
C
  320 Continue
      Read (17,'(A80)',END=330) z_style
      if (index (z_style,'# COMMENT01') .gt. 0) then
          Call UHRDAT (z_uhr,Z_datum)
          Read (17,'(A80)',END=330) z_style
          Write (z_style,'(''   TEXT = "'',A40,
     #      '' \n'',A8,2X,A5,1H")') z_comment,z_datum,z_uhr(1:5)
          WRITE (27,'(A80)') z_style
      else if (index (z_style,'# INFOLINE01') .gt. 0) then
          Read (17,'(A80)',END=330) z_style
          Write (z_style,'(''   TEXT = "Parameters: '',
     #                  2H\n,''Y_0_1 = '',F5.2,'' m, Y*_0_1 = '',F7.2,
     #                  '' m/s, t_A = '',F5.2,1H")') y0(3),y0(1),t_anf
          WRITE (27,'(A80)') z_style
      else if (index (z_style,'# INFOLINE02') .gt. 0) then
          Read (17,'(A80)',END=330) z_style
          Write (z_style,'(''   TEXT = "Y_0_2 = '',F5.2,
     #                     '' m, Y*_0_2 = '',F7.2,'' m/s, t_E = '',
     #                     1PG9.2,1H")') y0(4),y0(2),t_end
          WRITE (27,'(A80)') z_style
      else if (index (z_style,'# INFOLINE03') .gt. 0) then
          Read (17,'(A80)',END=330) z_style
          Write (z_style,'(''   TEXT = "M_1 = '',1PG09.2,'', '',
     #                     ''M_2 = '',1PG09.2,'', '',
     #                     ''S_m = '',1PG09.2,''[kg]'',1H")') m1,m2,sm
          WRITE (27,'(A80)') z_style
      else if (index (z_style,'# INFOLINE04') .gt. 0) then
          Read (17,'(A80)',END=330) z_style
          Write (z_style,'(''   TEXT = "D_1 = '',1PG10.3,
     #                     '' kg/s,     '',
     #                     ''D_2 = '',1PG10.3,'' kg/s '',1H")') d1,d2
          WRITE (27,'(A80)') z_style
      else if (index (z_style,'# INFOLINE05') .gt. 0) then
          Read (17,'(A80)',END=330) z_style
          Write (z_style,'(''   TEXT = "K_1 = '',1PG10.3,'' kg/s^2, '',
     #                     ''K_2 = '',1PG10.3,'' kg/s^2 '',
     #                       1H")') k1,k2
          WRITE (27,'(A80)') z_style
      else if (index (z_style,'# INFOLINE06') .gt. 0) then
          Read (17,'(A80)',END=330) z_style
          Write (z_style,'(''   TEXT = "K_m = '',1PG10.3,'' kg/s^2, '',
     #                     ''f_s = '',1PG10.3,'' N/m '',
     #                       1H")') km,fs
          WRITE (27,'(A80)') z_style
      else if (index (z_style,'# INFOLINE07') .gt. 0) then
          Read (17,'(A80)',END=330) z_style
          Write (z_style,'(''   TEXT = "f_0_1 = '',F7.3,'' Hz, '',
     #                     ''f_0_2 = '',F7.3,'' Hz, '',
     #                     ''`k = '',F6.3,'' kg/s^2 '',
     #                       1H")') f01,f02,kap
          WRITE (27,'(A80)') z_style
      else if (index (z_style,'# INFOLINE08') .gt. 0) then
          Read (17,'(A80)',END=330) z_style
          Write (z_style,'(''   TEXT = "a_0 = '',F6.2,'' N, '',
     #               ''   f_0 = '',F6.2,'' Hz,  '',
     #               ''`f = '',F6.1,'' [deg] '',1H")') a0,f0,phase
          WRITE (27,'(A80)') z_style
      else if (index (z_style,'# INFOLINE09') .gt. 0) then
          Read (17,'(A80)',END=330) z_style
          Write (z_style,'(''   TEXT = "`w* = '',F6.3,'' [-], '',
     #                 ''`x_p = '',F6.3,'' [-], '',
     #                 ''Ma = '',F6.3,'' [-] '',1H")') omred,xdr,dmach
          WRITE (27,'(A80)') z_style
      else
          write (27,'(A)') z_style
      end if
      goto 320
  330 Continue
C
      return
      end
